--[[
-- Copyright (c) 2012  Anton Savoshchanka (aka AntonioModer)
--
-- This software is provided 'as-is', without any express or implied
-- warranty.  In no event will the authors be held liable for any damages
-- arising from the use of this software.
--
-- Permission is granted to anyone to use this software for any purpose,
-- including commercial applications, and to alter it and redistribute it
-- freely, subject to the following restrictions:
--
-- 1. The origin of this software must not be misrepresented; you must not
--    claim that you wrote the original software. If you use this software
--    in a product, an acknowledgment in the product documentation would be
--    appreciated but is not required.
-- 2. Altered source versions must be plainly marked as such, and must not be
--    misrepresented as being the original software.
-- 3. This notice may not be removed or altered from any source distribution.
--]]

--[[
Love_Load
--]]



function loveLoad()
-- INIT --
-- initial graphics setup --
love.graphics.setBackgroundColor(104, 136, 248); 													-- color = blue
-- initial	PHYSICS --
love.physics.setMeter(64); 
physWorld = love.physics.newWorld(0, 50*64, true);												-- with gravity
-- physWorld = love.physics.newWorld(0, 0, true);														-- without gravity
-- break engine --
physWorld:setCallbacks(beginContact, endContact, preSolve, postSolve)
objCollA = 0;
objCollB = 0;
-- drag body --
mouseGetPhysBody = 0;																				-- body in mouse
mouseGetPhysBodyPressed = false;																
jointMouse = 0;
-- ray --
countMousePress = 0;

-- create phys objects --

local Ground = newObj('Entity', 'Ground');
Ground.setPhysBody(800/2, 600-25, "static", 2, 800, 50, nil); 	

local Roof = newObj('Entity', 'Roof');
Roof.setPhysBody(800/2, 25, "static", 2, 800, 50, nil); 	

local WallL = newObj('Entity', 'WallL');
WallL.setPhysBody(25, 600/2, "static", 2, 50, 600, nil); 	
	
local WallR = newObj('Entity', 'WallR');
WallR.setPhysBody(800-25, 600/2, "static", 2, 50, 600, nil); 	

local tabConvexPoints = {-50,10, 0,-50, 50,10, 0,100}														-- Convex  
-- local tabConvexPoints = {-200,-100, 0,-150, 200,0, 0,150}												-- Convex  
local Convex = newObj('Entity', 'Convex');
Convex.setPhysBody(400, 300, "dynamic", 4, nil, nil, tabConvexPoints); 
Convex.setDrawColor(153, 105, 26, 255);


-- WORLD RAY --
ray1 = {
	x1 = 0,
	y1 = 0,
	x2 = 0,
	y2 = 0,
	hitList = {}
}	    
ray2 = {
	x1 = 0,
	y1 = 0,
	x2 = 0,
	y2 = 0,
	hitList = {}
}

-- TEST --

-- WORLD RAY --
-- ray1 = {
	-- x1 = 400,
	-- y1 = 750,
	-- x2 = 400,
	-- y2 = 100,
	-- hitList = {}
-- }	    
-- ray2 = {
	-- x1 = 400,
	-- y1 = 100,
	-- x2 = 400,
	-- y2 = 750,
	-- hitList = {}
-- }
-- -- -- BUG1 FIX --
-- -- if math.floor(ray1.x1) == math.floor(ray1.x2) then
	-- -- ray1.x2 = ray1.x2+0.001;
	-- -- ray2.x1 = ray1.x2;
-- -- end
-- -- if math.floor(ray1.y1) == math.floor(ray1.y2) then
	-- -- ray1.y2 = ray1.y2+0.001;
	-- -- ray2.y1 = ray1.y2;
-- -- end	

-- if ray1.x2 ~= 0 then
	-- physWorld:rayCast(ray1.x1, ray1.y1, ray1.x2, ray1.y2, worldRayCastCallback1)
	-- physWorld:rayCast(ray2.x1, ray2.y1, ray2.x2, ray2.y2, worldRayCastCallback2)
-- end

-- ray1Start = {}
-- ray1End = {}
-- ray1Start.x = ray1.x1
-- ray1Start.y = ray1.y1
-- ray1End.x = ray1.x2
-- ray1End.y = ray1.y2	
-- sliceConvex(ray1Start, ray1End, ray1.hitList, ray2.hitList, nil)
end	-- loveLoad()
