--[[
-- Copyright (c) 2012  Anton Savoshchanka (aka AntonioModer)
--
-- This software is provided 'as-is', without any express or implied
-- warranty.  In no event will the authors be held liable for any damages
-- arising from the use of this software.
--
-- Permission is granted to anyone to use this software for any purpose,
-- including commercial applications, and to alter it and redistribute it
-- freely, subject to the following restrictions:
--
-- 1. The origin of this software must not be misrepresented; you must not
--    claim that you wrote the original software. If you use this software
--    in a product, an acknowledgment in the product documentation would be
--    appreciated but is not required.
-- 2. Altered source versions must be plainly marked as such, and must not be
--    misrepresented as being the original software.
-- 3. This notice may not be removed or altered from any source distribution.
--]]

--[[
Love_Update
--]]



function loveUpdate(dt)
physWorld:update(dt);

if love.mouse.isDown("l") then
	-- drag body --
	if jointMouse ~= 0 then
		jointMouse:setTarget(love.mouse.getPosition())
	end
	-- for draw ray --
	if love.keyboard.isDown("lctrl") or love.keyboard.isDown("rctrl") then
		if countMousePress == 1 then														
			ray1.x2 = love.mouse.getX()+0.01;												
			ray1.y2 = love.mouse.getY()+0.01;
			
			ray2.x1 = ray1.x2;											
			ray2.y1 = ray1.y2;
		end			
	end	
end


-- BREAK ENGINE v 0.1 --
-- break object (  -       beginContact())--
if objCollA ~= 0 and (objCollA.physShapeType == 3 or objCollA.physShapeType == 4) then
	-- speed obj --
	local vx, vy  = objCollA.physBody:getLinearVelocityFromLocalPoint( 0, 0 )	
	if  vx > 200 or vy > 200 then 									--     

		ray1.x1 = objCollA.tabObjContact.x;
		ray1.y1 = objCollA.tabObjContact.y;
		ray1.x2 = objCollA.tabObjContact.x+(objCollA.tabObjContact.normalX*3);
		ray1.y2 = objCollA.tabObjContact.y+(objCollA.tabObjContact.normalY*3);
		
		ray2.x2 = ray1.x1;
		ray2.y2 = ray1.y1;
		ray2.x1 = ray1.x2;
		ray2.y1 = ray1.y2;
		
		ray1.hitList = nil;
		ray2.hitList = nil;
		ray1.hitList = {}
		ray2.hitList = {}
		
		-- BUG1 FIX (always before rayCast()) --
		if math.floor(ray1.x1) == math.floor(ray1.x2) then
			ray1.x2 = ray1.x2+0.1;
			ray2.x1 = ray1.x2;
		end
		if math.floor(ray1.y1) == math.floor(ray1.y2) then
			ray1.y2 = ray1.y2+0.1;
			ray2.y1 = ray1.y2;
		end	
		physWorld:rayCast(ray1.x1, ray1.y1, ray1.x2, ray1.y2, worldRayCastCallback1)
		physWorld:rayCast(ray2.x1, ray2.y1, ray2.x2, ray2.y2, worldRayCastCallback2)

		ray1Start = nil
		ray1End = nil		
		ray1Start = {}
		ray1End = {}
		ray1Start.x = ray1.x1
		ray1Start.y = ray1.y1
		ray1End.x = ray1.x2
		ray1End.y = ray1.y2	
		
		-- THIS FUNCTION DONT WORC IN beginContact() (PHYSIC ENGINE DONT CREATE NEW BODY (BUG))
		sliceConvex(ray1Start, ray1End, ray1.hitList, ray2.hitList, objCollA)
		
		-- physWorld:update(dt)
		
		-- ray1.x2 = 0
		-- ray1.y2 = 0
		-- ray1.x1 = 0
		-- ray1.y1 = 0
	end
end	

if objCollB ~= 0 and (objCollB.physShapeType == 3 or objCollB.physShapeType == 4) then
	-- speed obj --
	local vx, vy  = objCollB.physBody:getLinearVelocityFromLocalPoint( 0, 0 )	
	if  vx > 200 or vy > 200 then 									--     

		ray1.x1 = objCollB.tabObjContact.x;
		ray1.y1 = objCollB.tabObjContact.y;
		ray1.x2 = objCollB.tabObjContact.x+(objCollB.tabObjContact.normalX*3);
		ray1.y2 = objCollB.tabObjContact.y+(objCollB.tabObjContact.normalY*3);
		
		ray2.x2 = ray1.x1;
		ray2.y2 = ray1.y1;
		ray2.x1 = ray1.x2;
		ray2.y1 = ray1.y2;
		
		ray1.hitList = nil;
		ray2.hitList = nil;
		ray1.hitList = {}
		ray2.hitList = {}
		
		-- BUG1 FIX (always before rayCast()) --
		if math.floor(ray1.x1) == math.floor(ray1.x2) then
			ray1.x2 = ray1.x2+0.1;
			ray2.x1 = ray1.x2;
		end
		if math.floor(ray1.y1) == math.floor(ray1.y2) then
			ray1.y2 = ray1.y2+0.1;
			ray2.y1 = ray1.y2;
		end	
		physWorld:rayCast(ray1.x1, ray1.y1, ray1.x2, ray1.y2, worldRayCastCallback1)
		physWorld:rayCast(ray2.x1, ray2.y1, ray2.x2, ray2.y2, worldRayCastCallback2)

		ray1Start = nil
		ray1End = nil		
		ray1Start = {}
		ray1End = {}
		ray1Start.x = ray1.x1
		ray1Start.y = ray1.y1
		ray1End.x = ray1.x2
		ray1End.y = ray1.y2	
		
		-- THIS FUNCTION DONT WORC IN beginContact() (PHYSIC ENGINE DONT CREATE NEW BODY (BUG))
		sliceConvex(ray1Start, ray1End, ray1.hitList, ray2.hitList, objCollB)
		
		-- physWorld:update(dt)
		
		-- ray1.x2 = 0
		-- ray1.y2 = 0
		-- ray1.x1 = 0
		-- ray1.y1 = 0
	end
end	

objCollA = 0;	-- switch global var
objCollB = 0;

-- TEST --

end	-- loveUpdate(dt)